/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

/***************************************************************************
*   ROM 2.4 is copyright 1993-1996 Russ Taylor                             *
*   ROM has been brought to you by the ROM consortium                      *
*       Russ Taylor (rtaylor@pacinfo.com)                                  *
*       Gabrielle Taylor (gtaylor@pacinfo.com)                             *
*       Brian Moore (rom@rom.efn.org)                                      *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/***************************************************************************
*   THE LABYRINTH is copyright 1996-2002 Sherene Neil and William          *
*       Wallace                                                            *
*   THE LABYRINTH is brought to you by THE LABYRINTH Team:                 *
*   Sherene Wallace (sherene-dw@comcast.net)                               *
*   William Wallace (williamwallace@comcast.net)                           *
*                                                                          *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/* 
 * color.h -=- Color structures and macros.
 * Written for Labyrinth DikuMUD copyright (C) 1995 James Bielman
 */

/*
 * This structure maps color names to color escapes.
 */
struct color_map_data
{
   char *color_escape;     /* the ansi escape sequence */
   char *color_name;       /* the name of the color */
   char *color_formatted;  /* color name formatted for `color' command */
};

extern struct color_map_data color_map[];

/*
 * Here are the ANSI color escapes.
 */
#define COLOR_OFF       "\033[m"

#define COLOR_BLACK        "\033[;30m"
#define COLOR_RED          "\033[;31m"
#define COLOR_GREEN        "\033[;32m"
#define COLOR_BROWN        "\033[;33m"
#define COLOR_BLUE         "\033[;34m"
#define COLOR_MAGENTA      "\033[;35m"
#define COLOR_CYAN         "\033[;36m"
#define COLOR_LIGHTGREY    "\033[;37m"

#define COLOR_GREY         "\033[;30;1m"
#define COLOR_LIGHTRED     "\033[;31;1m"
#define COLOR_LIGHTGREEN   "\033[;32;1m"
#define COLOR_YELLOW       "\033[;33;1m"
#define COLOR_LIGHTBLUE    "\033[;34;1m"
#define COLOR_LIGHTMAGENTA "\033[;35;1m"
#define COLOR_LIGHTCYAN    "\033[;36;1m"
#define COLOR_WHITE        "\033[;37;1m"

/*
 * Player configurable colors.
 */
struct color_config_data
{
   char *config_name;
   char *config_default;
   sh_int config_min_level;
};

extern struct color_config_data color_config[];
extern int num_config_colors;

/*
 * Indexes into config_data. Passed into act_new.
 */
#define C_NONE             -1

#define C_AUCTION	 0
#define C_BAMF_INOUT	 1
#define C_BORDERS	 2
#define C_CLANTALK	 3
#define C_QUESTION	 4
#define C_COMBAT_SELF    5
#define C_COMBAT_MOBS    6
//#define C_EFFECTS        5
//#define C_FLAGS          6
#define C_RELIGION	 7
#define C_GOSSIP	 8
#define C_GRATS		 9
#define C_GROUPTELL	10 
#define C_INFORMATION	11 
#define C_MOBILES	12
#define C_MUSIC		13
#define C_OBJECTS	14
#define C_PROMPT	15
#define C_PLAYERS	16
#define C_QUOTE 	17
#define C_ROOM_TITLES	18
#define C_SAY		19
#define C_SHOUT		20
#define C_TELL		21
#define C_TITLES	22
#define C_COMBAT_PLAYER 23
//#define C_WHISPER       23
#define C_YELL		24

#define C_IMMTALK	25
#define C_IMPTALK	26
#define C_WIZNET	27
#define C_CRETALK	28
#define C_ORATE		29


/*
 * Color macros.
 */
#define P_COLOR( ch, color )         ( ( color >= 0 && color < MAX_COLOR && !IS_NPC( ch ) && IS_SET( ch->comm, COMM_COLOR) ) ? ch->pcdata->colors[color] : "" )
#define P_COLOR_OFF( ch ) ( ( !IS_NPC( ch ) && IS_SET( ch->comm, COMM_COLOR) ) ? COLOR_OFF : "" )
#define P_COLOR_LITERAL( ch, color ) ( ( !IS_NPC( ch ) && IS_SET( ch->comm, COMM_COLOR) ) ? color : "" )

/*
 * Function Prototypes for color.c
 */
int color_lookup_config_index args( (char *name ) );
char *color_lookup_color args( (char *color ) );
char *color_lookup_escape args( (char *escape ) );
