/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

/***************************************************************************
*   ROM 2.4 is copyright 1993-1996 Russ Taylor                             *
*   ROM has been brought to you by the ROM consortium                      *
*       Russ Taylor (rtaylor@pacinfo.com)                                  *
*       Gabrielle Taylor (gtaylor@pacinfo.com)                             *
*       Brian Moore (rom@rom.efn.org)                                      *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/***************************************************************************
*   THE LABYRINTH is copyright 1996-2002 Sherene Neil and William          *
*       Wallace                                                            *
*   THE LABYRINTH is brought to you by THE LABYRINTH Team:                 *
*   Sherene Wallace (sherene-dw@comcast.net)                               *
*   William Wallace (williamwallace@comcast.net)                           *
*                                                                          *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/* this is a listing of all the commands and command related data */

/* for command types */
#define NL	MAX_LEVEL + 1	/* no level - olc only */
#define ML	MAX_LEVEL	/* implementor */
#define L1	MAX_LEVEL - 1  	/* creator */
#define L2	MAX_LEVEL - 2	/* supreme being */
#define L3	MAX_LEVEL - 3	/* deity */
#define L4	MAX_LEVEL - 4	/* god */
#define L5	MAX_LEVEL - 5	/* immortal */
#define L6	MAX_LEVEL - 6	/* demigod */
#define L7	MAX_LEVEL - 7	/* angel */
#define L8	MAX_LEVEL - 8	/* avatar */
#define IM	LEVEL_IMMORTAL 	/* avatar */
#define HE	LEVEL_HERO	/* hero */

#define COM_INGORE	1

#define COM_SHOW	A
#define COM_HIDE	B



/*
 * Structure for a command in the command lookup table.
 */
struct	cmd_type
{
    char * const	name;
    DO_FUN *		do_fun;
    sh_int		position;
    sh_int		level;
    sh_int		olc_level;
    sh_int		log;
    bool		show;
    bool		no_paralysis;
    bool		breaks_bard_song;
};

/* the command table itself */
extern	const	struct	cmd_type	cmd_table	[];

/*
 * Command functions.
 * Defined in act_*.c (mostly).
 */
DECLARE_DO_FUN( do_advance	);
DECLARE_DO_FUN( do_affects	);
DECLARE_DO_FUN( do_afk		);
DECLARE_DO_FUN( do_alia		);
DECLARE_DO_FUN( do_alias	);
DECLARE_DO_FUN( do_allow	);
DECLARE_DO_FUN( do_answer	);
DECLARE_DO_FUN( do_areas	);
DECLARE_DO_FUN( do_at		);
DECLARE_DO_FUN( do_auction	);
DECLARE_DO_FUN( do_autoassist	);
DECLARE_DO_FUN( do_autoexit	);
DECLARE_DO_FUN( do_autogold	);
//DECLARE_DO_FUN( do_autolist	);
DECLARE_DO_FUN( do_autoloot	);
DECLARE_DO_FUN( do_autosac	);
DECLARE_DO_FUN( do_autosplit	);
DECLARE_DO_FUN( do_backstab	);
DECLARE_DO_FUN( do_bamfin	);
DECLARE_DO_FUN( do_bamfout	);
DECLARE_DO_FUN( do_ban		);
DECLARE_DO_FUN( do_bash		);
DECLARE_DO_FUN( do_berserk	);
DECLARE_DO_FUN( do_boottime     );
DECLARE_DO_FUN( do_brandish	);
DECLARE_DO_FUN( do_brief	);
DECLARE_DO_FUN( do_bugs		);
DECLARE_DO_FUN(	do_buki		);
DECLARE_DO_FUN( do_buy		);
DECLARE_DO_FUN( do_cast		);
DECLARE_DO_FUN( do_changes	);
//DECLARE_DO_FUN( do_channels	);
DECLARE_DO_FUN( do_circle	);
DECLARE_DO_FUN( do_clockwise	);
DECLARE_DO_FUN( do_clone	);
DECLARE_DO_FUN( do_close	);
DECLARE_DO_FUN( do_commands	);
DECLARE_DO_FUN( do_combine	);
DECLARE_DO_FUN( do_compact	);
DECLARE_DO_FUN( do_compare	);
DECLARE_DO_FUN( do_consider	);
DECLARE_DO_FUN( do_count	);
DECLARE_DO_FUN( do_counterclockwise );
DECLARE_DO_FUN( do_credits	);
DECLARE_DO_FUN( do_deaf		);
DECLARE_DO_FUN( do_delet	);
DECLARE_DO_FUN( do_delete	);
DECLARE_DO_FUN( do_deny		);
DECLARE_DO_FUN( do_description	);
DECLARE_DO_FUN( do_dirt		);
DECLARE_DO_FUN( do_disarm	);
DECLARE_DO_FUN( do_disconnect	);
DECLARE_DO_FUN( do_down		);
DECLARE_DO_FUN( do_drink	);
DECLARE_DO_FUN( do_drop		);
DECLARE_DO_FUN( do_dump		);
DECLARE_DO_FUN( do_east		);
DECLARE_DO_FUN( do_eat		);
DECLARE_DO_FUN( do_echo		);
DECLARE_DO_FUN( do_emote	);
DECLARE_DO_FUN( do_enter	);
DECLARE_DO_FUN( do_envenom	);
DECLARE_DO_FUN( do_equipment	);
DECLARE_DO_FUN( do_examine	);
DECLARE_DO_FUN( do_exits	);
DECLARE_DO_FUN( do_fill		);
DECLARE_DO_FUN( do_flag		);
DECLARE_DO_FUN( do_flee		);
DECLARE_DO_FUN( do_follow	);
DECLARE_DO_FUN( do_forage	);
DECLARE_DO_FUN( do_sneak	);
DECLARE_DO_FUN( do_force	);
DECLARE_DO_FUN( do_freeze	);
DECLARE_DO_FUN( do_gain		);
DECLARE_DO_FUN(	do_get		);
DECLARE_DO_FUN( do_give		);
DECLARE_DO_FUN( do_gossip	);
DECLARE_DO_FUN( do_goto		);
DECLARE_DO_FUN( do_grats	);
DECLARE_DO_FUN( do_group	);
DECLARE_DO_FUN( do_groups	);
DECLARE_DO_FUN( do_gtell	);
DECLARE_DO_FUN( do_guild    	);
DECLARE_DO_FUN( do_heal		);
DECLARE_DO_FUN( do_help		);
DECLARE_DO_FUN( do_hide		);
DECLARE_DO_FUN( do_holylight	);
DECLARE_DO_FUN( do_homehide	);
DECLARE_DO_FUN( do_idea		);
DECLARE_DO_FUN( do_immtalk	);
DECLARE_DO_FUN( do_incognito	);
DECLARE_DO_FUN( do_clantalk	);
DECLARE_DO_FUN( do_imotd	);
DECLARE_DO_FUN( do_inventory	);
DECLARE_DO_FUN( do_invis	);
DECLARE_DO_FUN( do_kick		);
DECLARE_DO_FUN( do_kill		);
DECLARE_DO_FUN( do_list		);
DECLARE_DO_FUN( do_load		);
DECLARE_DO_FUN( do_lock		);
DECLARE_DO_FUN( do_log		);
DECLARE_DO_FUN( do_look		);
DECLARE_DO_FUN( do_lore         );
DECLARE_DO_FUN( do_memory	);
DECLARE_DO_FUN( do_mfind	);
DECLARE_DO_FUN( do_mload	);
DECLARE_DO_FUN( do_mset		);
DECLARE_DO_FUN( do_mstat	);
DECLARE_DO_FUN( do_mwhere	);
DECLARE_DO_FUN( do_motd		);
DECLARE_DO_FUN( do_murde	);
DECLARE_DO_FUN( do_murder	);
DECLARE_DO_FUN( do_music	);
DECLARE_DO_FUN( do_news		);
DECLARE_DO_FUN( do_nochannels	);
DECLARE_DO_FUN( do_noemote	);
DECLARE_DO_FUN( do_nofollow	);
DECLARE_DO_FUN( do_noloot	);
DECLARE_DO_FUN( do_north	);
DECLARE_DO_FUN( do_northeast	);
DECLARE_DO_FUN( do_northwest	);
DECLARE_DO_FUN( do_noshout	);
DECLARE_DO_FUN( do_nosummon	);
DECLARE_DO_FUN( do_note		);
DECLARE_DO_FUN( do_notell	);
DECLARE_DO_FUN( do_ofind	);
DECLARE_DO_FUN( do_oload	);
DECLARE_DO_FUN( do_omni         );
DECLARE_DO_FUN( do_open		);
DECLARE_DO_FUN( do_order	);
DECLARE_DO_FUN( do_oset		);
DECLARE_DO_FUN( do_ostat	);
DECLARE_DO_FUN( do_outfit	);
DECLARE_DO_FUN( do_owhere	);
DECLARE_DO_FUN( do_pardon	);
DECLARE_DO_FUN( do_password	);
DECLARE_DO_FUN( do_page		);
DECLARE_DO_FUN(	do_peace	);
DECLARE_DO_FUN( do_pecho	);
DECLARE_DO_FUN( do_penalty	);
DECLARE_DO_FUN( do_permban	);
DECLARE_DO_FUN( do_pick		);
DECLARE_DO_FUN( do_play		);
DECLARE_DO_FUN( do_pmote	);
DECLARE_DO_FUN( do_pose		);
DECLARE_DO_FUN( do_pour		);
DECLARE_DO_FUN( do_practice	);
DECLARE_DO_FUN( do_prefi	);
DECLARE_DO_FUN( do_prefix	);
DECLARE_DO_FUN( do_preserve	);
DECLARE_DO_FUN( do_print	);
DECLARE_DO_FUN( do_prompt	);
DECLARE_DO_FUN( do_protect	);
DECLARE_DO_FUN( do_purge	);
DECLARE_DO_FUN( do_put		);
DECLARE_DO_FUN( do_quaff	);
DECLARE_DO_FUN( do_question	);
DECLARE_DO_FUN( do_qui		);
DECLARE_DO_FUN( do_quiet	);
DECLARE_DO_FUN( do_quit		);
DECLARE_DO_FUN( do_quote	);
DECLARE_DO_FUN( do_read		);
DECLARE_DO_FUN( do_reboo	);
DECLARE_DO_FUN( do_reboot	);
DECLARE_DO_FUN( do_recall	);
DECLARE_DO_FUN( do_recho	);
DECLARE_DO_FUN( do_recite	);
DECLARE_DO_FUN( do_remove	);
DECLARE_DO_FUN( do_rent		);
DECLARE_DO_FUN( do_replay	);
DECLARE_DO_FUN( do_reply	);
DECLARE_DO_FUN( do_report	);
DECLARE_DO_FUN( do_rescue	);
DECLARE_DO_FUN( do_rest		);
DECLARE_DO_FUN( do_restore	);
DECLARE_DO_FUN( do_return	);
DECLARE_DO_FUN( do_rset		);
DECLARE_DO_FUN( do_rstat	);
DECLARE_DO_FUN( do_rules	);
DECLARE_DO_FUN( do_sacrifice	);
DECLARE_DO_FUN( do_save		);
DECLARE_DO_FUN( do_say		);
DECLARE_DO_FUN( do_score	);
DECLARE_DO_FUN( do_scroll	);
DECLARE_DO_FUN( do_sell		);
DECLARE_DO_FUN( do_set		);
DECLARE_DO_FUN( do_shout	);
DECLARE_DO_FUN( do_show		);
DECLARE_DO_FUN( do_shutdow	);
DECLARE_DO_FUN( do_shutdown	);
DECLARE_DO_FUN( do_sit		);
DECLARE_DO_FUN( do_skills	);
DECLARE_DO_FUN( do_sla		);
DECLARE_DO_FUN( do_slay		);
DECLARE_DO_FUN( do_sleep	);
DECLARE_DO_FUN( do_slookup	);
DECLARE_DO_FUN( do_smote	);
DECLARE_DO_FUN( do_sneak	);
DECLARE_DO_FUN( do_snoop	);
DECLARE_DO_FUN( do_socials	);
DECLARE_DO_FUN( do_south	);
DECLARE_DO_FUN( do_southeast	);
DECLARE_DO_FUN( do_southwest	);
DECLARE_DO_FUN( do_sockets	);
DECLARE_DO_FUN( do_spells	);
DECLARE_DO_FUN( do_split	);
DECLARE_DO_FUN( do_sset		);
DECLARE_DO_FUN( do_stand	);
DECLARE_DO_FUN( do_stat		);
DECLARE_DO_FUN( do_steal	);
DECLARE_DO_FUN( do_story	);
DECLARE_DO_FUN( do_string	);
DECLARE_DO_FUN( do_switch	);
DECLARE_DO_FUN( do_tell		);
DECLARE_DO_FUN( do_time		);
DECLARE_DO_FUN( do_title	);
DECLARE_DO_FUN( do_toggle	);
DECLARE_DO_FUN( do_train	);
DECLARE_DO_FUN( do_transfer	);
DECLARE_DO_FUN( do_trip		);
DECLARE_DO_FUN( do_trust	);
DECLARE_DO_FUN( do_typo		);
DECLARE_DO_FUN( do_unalias	);
DECLARE_DO_FUN( do_unlock	);
DECLARE_DO_FUN( do_unread	);
DECLARE_DO_FUN( do_up		);
DECLARE_DO_FUN( do_value	);
DECLARE_DO_FUN( do_visible	);
DECLARE_DO_FUN( do_violate	);
DECLARE_DO_FUN( do_vnum		);
DECLARE_DO_FUN( do_wake		);
DECLARE_DO_FUN( do_warmboot	);
DECLARE_DO_FUN( do_wear		);
DECLARE_DO_FUN( do_weather	);
DECLARE_DO_FUN( do_west		);
DECLARE_DO_FUN( do_where	);
DECLARE_DO_FUN( do_who		);
DECLARE_DO_FUN( do_whois	);
DECLARE_DO_FUN( do_wimpy	);
DECLARE_DO_FUN( do_wizhelp	);
DECLARE_DO_FUN( do_wizlock	);
DECLARE_DO_FUN( do_wizlist	);
DECLARE_DO_FUN( do_wiznet	);
DECLARE_DO_FUN( do_worth	);
DECLARE_DO_FUN( do_yell		);
DECLARE_DO_FUN( do_zap		);
DECLARE_DO_FUN( do_zecho	);

DECLARE_DO_FUN( do_cure     );
DECLARE_DO_FUN( do_anathametize);
DECLARE_DO_FUN( do_absolve  );
DECLARE_DO_FUN( do_scan     );
DECLARE_DO_FUN( do_imptalk	);
DECLARE_DO_FUN( do_religion	);
DECLARE_DO_FUN( do_intone	);
DECLARE_DO_FUN( do_boom		);
DECLARE_DO_FUN( do_track	);
DECLARE_DO_FUN( do_tail		);
DECLARE_DO_FUN( do_priority	);
DECLARE_DO_FUN( do_whisper	);
DECLARE_DO_FUN( do_murmur	);
DECLARE_DO_FUN( do_transin	);
DECLARE_DO_FUN( do_transout	);
DECLARE_DO_FUN( do_transvict);
DECLARE_DO_FUN( do_adverbs	);
DECLARE_DO_FUN( do_ki_punch	);
DECLARE_DO_FUN( do_ki_shout	);
DECLARE_DO_FUN( do_eagle_claw);
DECLARE_DO_FUN( do_deposit	);
DECLARE_DO_FUN( do_balance	);
DECLARE_DO_FUN( do_withdraw	);
DECLARE_DO_FUN( do_color	);
DECLARE_DO_FUN( do_donate	);
DECLARE_DO_FUN( do_second	);
DECLARE_DO_FUN( do_accept	);
DECLARE_DO_FUN( do_defrock	);
DECLARE_DO_FUN( do_deputize	);
DECLARE_DO_FUN( do_petition	);
DECLARE_DO_FUN( do_name		);
DECLARE_DO_FUN( do_cretalk	);
DECLARE_DO_FUN( do_anum		);
DECLARE_DO_FUN( do_asave	);
DECLARE_DO_FUN( do_unsave	);
DECLARE_DO_FUN( do_area_credits);
DECLARE_DO_FUN( do_area_name);
DECLARE_DO_FUN( do_area_creator);
DECLARE_DO_FUN( do_create	);
DECLARE_DO_FUN( do_room		);
DECLARE_DO_FUN( do_mobile	);
DECLARE_DO_FUN( do_object	);
DECLARE_DO_FUN( do_area_flags);
DECLARE_DO_FUN( do_olclevel	);
DECLARE_DO_FUN( do_olchelp	);
DECLARE_DO_FUN( do_areview	);
DECLARE_DO_FUN( do_appearance);
DECLARE_DO_FUN( do_ride		);
DECLARE_DO_FUN( do_dismount	);
DECLARE_DO_FUN( do_dislodge	);
DECLARE_DO_FUN( do_fire		);
DECLARE_DO_FUN( do_draw		);
DECLARE_DO_FUN( do_mgoto	);
DECLARE_DO_FUN( do_trample	);
DECLARE_DO_FUN( do_induct	);
DECLARE_DO_FUN( do_joust	);
DECLARE_DO_FUN( do_mob		);
DECLARE_DO_FUN( do_mpstat	);
DECLARE_DO_FUN( do_mpdump	);
DECLARE_DO_FUN( do_surrender);
DECLARE_DO_FUN( do_orate	);
DECLARE_DO_FUN( do_nomercy	);
DECLARE_DO_FUN( do_unmount	);
DECLARE_DO_FUN( do_detrap	);
DECLARE_DO_FUN( do_program	);
DECLARE_DO_FUN( do_opstat	);
DECLARE_DO_FUN( do_trap		);
DECLARE_DO_FUN( do_rpstat	);
DECLARE_DO_FUN( do_areset	);
DECLARE_DO_FUN( do_escape	);
DECLARE_DO_FUN( do_territory    );
DECLARE_DO_FUN( do_message	);
DECLARE_DO_FUN( do_nocancel	);
DECLARE_DO_FUN( do_account	);
DECLARE_DO_FUN( do_sap		);
DECLARE_DO_FUN( do_style	);
DECLARE_DO_FUN( do_sing         );
DECLARE_DO_FUN( do_ansi         );
DECLARE_DO_FUN( do_whereami	);
DECLARE_DO_FUN( do_promote	);
DECLARE_DO_FUN( do_demote	);
DECLARE_DO_FUN( do_cdeposit	);
DECLARE_DO_FUN( do_cbalance	);
DECLARE_DO_FUN( do_cwithdraw	);
DECLARE_DO_FUN( do_tdeposit	);
DECLARE_DO_FUN( do_tbalance	);
DECLARE_DO_FUN( do_twithdraw	);
DECLARE_DO_FUN( do_skillstat	);
DECLARE_DO_FUN( do_spellstat	);
DECLARE_DO_FUN( do_pload	);
DECLARE_DO_FUN( do_punload	);
DECLARE_DO_FUN( do_sound	);
DECLARE_DO_FUN( do_area_sound	);
DECLARE_DO_FUN( do_bite         );
DECLARE_DO_FUN( do_eqstat       );
DECLARE_DO_FUN( do_nodelete     );
DECLARE_DO_FUN( do_customizations);
DECLARE_DO_FUN( do_xp           );




